Index: /branches/2013/dev_MERGE_2013/NEMOGCM/NEMO/OPA_SRC/BDY/bdyice_lim.F90
===================================================================
--- /branches/2013/dev_MERGE_2013/NEMOGCM/NEMO/OPA_SRC/BDY/bdyice_lim.F90	(revision 4332)
+++ /branches/2013/dev_MERGE_2013/NEMOGCM/NEMO/OPA_SRC/BDY/bdyice_lim.F90	(revision 4333)
@@ -45,4 +45,5 @@
 
    REAL(wp) ::   epsi20 = 1.e-20_wp  ! module constants
+   REAL(wp) ::   epsi10 = 1.e-10_wp  ! min area allowed by ice model
    !!----------------------------------------------------------------------
    !! NEMO/OPA 3.3 , NEMO Consortium (2010)
@@ -91,13 +92,18 @@
       INTEGER,         INTENT(in) ::   ib_bdy  ! BDY set index      !!
 
+      INTEGER  ::   jpbound            ! 0 = incoming ice
+                                       ! 1 = outgoing ice
       INTEGER  ::   jb, jk, jgrd, jl   ! dummy loop indices
-      INTEGER  ::   ji, jj             ! local scalar
+      INTEGER  ::   ji, jj, ii, ij     ! local scalar
       REAL(wp) ::   zwgt, zwgt1        ! local scalar
-      REAL(wp) ::   zinda, ztmelts
+      REAL(wp) ::   zinda, ztmelts, zdh
+
+      REAL(wp), PARAMETER  ::   zsal = 6.3    ! arbitrary salinity    for incoming ice
+      REAL(wp), PARAMETER  ::   ztem = 270.0  ! arbitrary temperature for incoming ice
+      REAL(wp), PARAMETER  ::   zage = 30.0   ! arbitrary age         for incoming ice
       !!------------------------------------------------------------------------------
       !
       IF( nn_timing == 1 ) CALL timing_start('bdy_ice_frs')
       !
-      !IF( kt /= nit000 ) THEN
       jgrd = 1      ! Everything is at T-points here
       !
@@ -170,64 +176,92 @@
             ht_i(ji,jj,jl) = ( ht_i(ji,jj,jl) * zwgt1 + dta%ht_i(jb,jl) * zwgt ) * tmask(ji,jj,1)  ! Ice depth 
             ht_s(ji,jj,jl) = ( ht_s(ji,jj,jl) * zwgt1 + dta%ht_s(jb,jl) * zwgt ) * tmask(ji,jj,1)  ! Snow depth
+
+            ! -----------------
+            ! Pathological case
+            ! -----------------
+            ! In case a) snow load would be in excess or b) ice is coming into a warmer environment that would lead to 
+            ! very large transformation from snow to ice (see limthd_dh.F90)
+
+            ! Then, a) transfer the snow excess into the ice (different from limthd_dh)
+            zdh = MAX( 0._wp, ( rhosn * ht_s(ji,jj,jl) + ( rhoic - rau0 ) * ht_i(ji,jj,jl) ) * r1_rau0 )
+            ! Or, b) transfer all the snow into ice (if incoming ice is likely to melt as it comes into a warmer environment)
+            !zdh = MAX( 0._wp, ht_s(ji,jj,jl) * rhosn / rhoic )
+
+            ! recompute ht_i, ht_s
+            ht_i(ji,jj,jl) = MIN( hi_max(jl), ht_i(ji,jj,jl) + zdh )
+            ht_s(ji,jj,jl) = MAX( 0._wp, ht_s(ji,jj,jl) - zdh * rhoic / rhosn ) 
+
          ENDDO
          CALL lbc_bdy_lnk(  a_i(:,:,jl), 'T', 1., ib_bdy )
          CALL lbc_bdy_lnk( ht_i(:,:,jl), 'T', 1., ib_bdy )
          CALL lbc_bdy_lnk( ht_s(:,:,jl), 'T', 1., ib_bdy )
-
+      ENDDO
+      ! retrieve at_i
+      at_i(:,:) = 0._wp
+      DO jl = 1, jpl
+         at_i(:,:) = a_i(:,:,jl) + at_i(:,:)
+      END DO
+
+      DO jl = 1, jpl
          DO jb = 1, idx%nblen(jgrd)
             ji    = idx%nbi(jb,jgrd)
             jj    = idx%nbj(jb,jgrd)
-            ! clem : condition on ice thickness depends on the ice velocity
-            ! if velocity is outward (strictly), then ice thickness, volume... must be equal to adjacent values 
-            IF ( u_ice(ji+1,jj  ) < 0. .AND. umask(ji-1,jj  ,1) == 0. ) THEN
-               ht_i(ji,jj,jl) = ht_i(ji+1,jj  ,jl)
-               a_i (ji,jj,jl) = a_i (ji+1,jj  ,jl)
-               ht_s(ji,jj,jl) = ht_s(ji+1,jj  ,jl)
-            ENDIF
-            IF ( u_ice(ji-1,jj  ) > 0. .AND. umask(ji+1,jj  ,1) == 0. ) THEN
-               ht_i(ji,jj,jl) = ht_i(ji-1,jj  ,jl)
-               a_i (ji,jj,jl) = a_i (ji-1,jj  ,jl)
-               ht_s(ji,jj,jl) = ht_s(ji-1,jj  ,jl)
-            ENDIF
-            IF ( v_ice(ji  ,jj+1) < 0. .AND. vmask(ji  ,jj-1,1) == 0. ) THEN
-               ht_i(ji,jj,jl) = ht_i(ji  ,jj+1,jl)
-               a_i (ji,jj,jl) = a_i (ji  ,jj+1,jl)
-               ht_s(ji,jj,jl) = ht_s(ji  ,jj+1,jl)
-            ENDIF
-            IF ( v_ice(ji  ,jj-1) > 0. .AND. vmask(ji  ,jj+1,1) == 0. ) THEN
-               ht_i(ji,jj,jl) = ht_i(ji  ,jj-1,jl)
-               a_i (ji,jj,jl) = a_i (ji  ,jj-1,jl)
-               ht_s(ji,jj,jl) = ht_s(ji  ,jj-1,jl)
-            ENDIF
-
-            zinda = 1.0 - MAX( 0.0_wp , SIGN ( 1.0_wp , - a_i(ji,jj,jl) ) ) ! 0 if no ice
-            ! --------------------
+
+            ! condition on ice thickness depends on the ice velocity
+            ! if velocity is outward (strictly), then ice thickness, volume... must be equal to adjacent values
+            jpbound = 0; ii = ji; ij = jj;
+
+            IF ( u_ice(ji+1,jj  ) < 0. .AND. umask(ji-1,jj  ,1) == 0. ) jpbound = 1; ii = ji+1; ij = jj
+            IF ( u_ice(ji-1,jj  ) > 0. .AND. umask(ji+1,jj  ,1) == 0. ) jpbound = 1; ii = ji-1; ij = jj
+            IF ( v_ice(ji  ,jj+1) < 0. .AND. vmask(ji  ,jj-1,1) == 0. ) jpbound = 1; ii = ji  ; ij = jj+1
+            IF ( v_ice(ji  ,jj-1) > 0. .AND. vmask(ji  ,jj+1,1) == 0. ) jpbound = 1; ii = ji  ; ij = jj-1
+
+            zinda = 1.0 - MAX( 0.0_wp , SIGN ( 1.0_wp , - at_i(ii,ij) + 0.01 ) ) ! 0 if no ice
+
+            ! concentration and thickness
+            a_i (ji,jj,jl) = a_i (ii,ij,jl) * zinda
+            ht_i(ji,jj,jl) = ht_i(ii,ij,jl) * zinda
+            ht_s(ji,jj,jl) = ht_s(ii,ij,jl) * zinda
+
             ! Ice and snow volumes
-            ! --------------------
             v_i(ji,jj,jl) = ht_i(ji,jj,jl) * a_i(ji,jj,jl)
             v_s(ji,jj,jl) = ht_s(ji,jj,jl) * a_i(ji,jj,jl)
 
-            ! -------------
-            ! Ice salinity
-            !---------------
-            sm_i(ji,jj,jl)   = zinda * bulk_sal  + ( 1.0 - zinda ) * s_i_min
+            SELECT CASE( jpbound )
+
+            CASE( 0 ) ! velocity is inward
+
+               ! Ice salinity, age, temperature
+               sm_i(ji,jj,jl)   = zinda * zsal  + ( 1.0 - zinda ) * s_i_min
+               o_i(ji,jj,jl)    = zinda * zage  + ( 1.0 - zinda )
+               t_su(ji,jj,jl)   = zinda * ztem  + ( 1.0 - zinda ) * ztem
+               DO jk = 1, nlay_s
+                  t_s(ji,jj,jk,jl) = zinda * ztem + ( 1.0 - zinda ) * rtt
+               END DO
+               DO jk = 1, nlay_i
+                  t_i(ji,jj,jk,jl) = zinda * ztem + ( 1.0 - zinda ) * rtt 
+                  s_i(ji,jj,jk,jl) = zinda * zsal + ( 1.0 - zinda ) * s_i_min
+               END DO
+               
+            CASE( 1 ) ! velocity is outward
+ 
+               ! Ice salinity, age, temperature
+               sm_i(ji,jj,jl)   = zinda * sm_i(ii,ij,jl)  + ( 1.0 - zinda ) * s_i_min
+               o_i(ji,jj,jl)    = zinda * o_i(ii,ij,jl)   + ( 1.0 - zinda )
+               t_su(ji,jj,jl)   = zinda * t_su(ii,ij,jl)  + ( 1.0 - zinda ) * rtt
+               DO jk = 1, nlay_s
+                  t_s(ji,jj,jk,jl) = zinda * t_s(ii,ij,jk,jl) + ( 1.0 - zinda ) * rtt
+               END DO
+               DO jk = 1, nlay_i
+                  t_i(ji,jj,jk,jl) = zinda * t_i(ii,ij,jk,jl) + ( 1.0 - zinda ) * rtt
+                  s_i(ji,jj,jk,jl) = zinda * s_i(ii,ij,jk,jl) + ( 1.0 - zinda ) * s_i_min
+               END DO
+
+            END SELECT
+
+            ! contents
             smv_i(ji,jj,jl)  = MIN( sm_i(ji,jj,jl) , sss_m(ji,jj) ) * v_i(ji,jj,jl)
-            
-            !----------
-            ! Ice age
-            !----------
-            o_i(ji,jj,jl)    = zinda * 1.0   + ( 1.0 - zinda )
             oa_i(ji,jj,jl)   = o_i(ji,jj,jl) * a_i(ji,jj,jl)
-            
-            !------------------------------
-            ! Sea ice surface temperature
-            !------------------------------
-            t_su(ji,jj,jl)   = zinda * 270.0 + ( 1.0 - zinda ) * t_bo(ji,jj)
-            
-            !------------------------------------
-            ! Snow temperature and heat content
-            !------------------------------------
             DO jk = 1, nlay_s
-               t_s(ji,jj,jk,jl) = zinda * 270.00 + ( 1.0 - zinda ) * rtt
                ! Snow energy of melting
                e_s(ji,jj,jk,jl) = zinda * rhosn * ( cpic * ( rtt - t_s(ji,jj,jk,jl) ) + lfus )
@@ -235,33 +269,22 @@
                e_s(ji,jj,jk,jl) = e_s(ji,jj,jk,jl) / unit_fac
                ! Multiply by volume, so that heat content in 10^9 Joules
-               e_s(ji,jj,jk,jl) = e_s(ji,jj,jk,jl) * area(ji,jj) * &
-                    v_s(ji,jj,jl)  / nlay_s
-            END DO !jk
-            
-            !-----------------------------------------------
-            ! Ice salinities, temperature and heat content 
-            !-----------------------------------------------
+               e_s(ji,jj,jk,jl) = e_s(ji,jj,jk,jl) * area(ji,jj) * v_s(ji,jj,jl) / nlay_s
+            END DO
             DO jk = 1, nlay_i
-               t_i(ji,jj,jk,jl) = zinda * 270.00 + ( 1.0 - zinda ) * rtt 
-               s_i(ji,jj,jk,jl) = zinda * bulk_sal + ( 1.0 - zinda ) * s_i_min
-               ztmelts          = - tmut * s_i(ji,jj,jk,jl) + rtt !Melting temperature in K
-               
+               ztmelts          = - tmut * s_i(ji,jj,jk,jl) + rtt !Melting temperature in K                  
                ! heat content per unit volume
                e_i(ji,jj,jk,jl) = zinda * rhoic * &
-                    (   cpic    * ( ztmelts - t_i(ji,jj,jk,jl) ) &
-                    +   lfus    * ( 1.0 - (ztmelts-rtt) / MIN((t_i(ji,jj,jk,jl)-rtt),-epsi20) ) &
-                    - rcp      * ( ztmelts - rtt ) )
-               
+                  (   cpic    * ( ztmelts - t_i(ji,jj,jk,jl) ) &
+                  +   lfus    * ( 1.0 - (ztmelts-rtt) / MIN((t_i(ji,jj,jk,jl)-rtt),-epsi20) ) &
+                  - rcp      * ( ztmelts - rtt ) )
                ! Correct dimensions to avoid big values
                e_i(ji,jj,jk,jl) = e_i(ji,jj,jk,jl) / unit_fac 
-               
                ! Mutliply by ice volume, and divide by number of layers to get heat content in 10^9 J
-               e_i(ji,jj,jk,jl) = e_i(ji,jj,jk,jl) * & 
-                    area(ji,jj) * a_i(ji,jj,jl) * ht_i(ji,jj,jl) / nlay_i
-            END DO ! jk
+               e_i(ji,jj,jk,jl) = e_i(ji,jj,jk,jl) * area(ji,jj) * a_i(ji,jj,jl) * ht_i(ji,jj,jl) / nlay_i
+            END DO
+
 
          END DO !jb
  
-
          CALL lbc_bdy_lnk(  a_i(:,:,jl), 'T', 1., ib_bdy )                                         ! lateral boundary conditions
          CALL lbc_bdy_lnk( ht_i(:,:,jl), 'T', 1., ib_bdy )
@@ -288,5 +311,4 @@
 #endif
       !      
-      !ENDIF !nit000/=0
       IF( nn_timing == 1 ) CALL timing_stop('bdy_ice_frs')
       !
@@ -294,18 +316,16 @@
 
 
-   SUBROUTINE bdy_ice_lim_dyn( kn, pvar1, pvar2, pvar12 )
+   SUBROUTINE bdy_ice_lim_dyn( cd_type )
       !!------------------------------------------------------------------------------
       !!                 ***  SUBROUTINE bdy_ice_lim_dyn  ***
       !!                    
       !! ** Purpose : Apply dynamics boundary conditions for sea-ice in the cas of unstructured open boundaries.
-      !!      kn = 1: u_ice and v_ice are equal to the value of the adjacent grid point if this latter is not ice free
+      !!              u_ice and v_ice are equal to the value of the adjacent grid point if this latter is not ice free
       !!              if adjacent grid point is ice free, then u_ice and v_ice are equal to ocean velocities
-      !!      kn = 2: the stress tensor is set to 0 (i.e. pvar1, pvar2, pvar12)
       !!
       !! 2013-06 : C. Rousset
       !!------------------------------------------------------------------------------
       !!
-      INTEGER,  INTENT( in    )                           ::   kn     ! set up of ice vel (kn=1) or stress tensor (kn=2)
-      REAL(wp), INTENT( inout ), DIMENSION(:,:), OPTIONAL ::   pvar1, pvar2, pvar12  ! stress tensor components (zs1,zs2,zs12) 
+      CHARACTER(len=1), INTENT(in)  ::   cd_type   ! nature of velocity grid-points
       INTEGER  ::   jb, jgrd   ! dummy loop indices
       INTEGER  ::   ji, jj             ! local scalar
@@ -317,88 +337,84 @@
       !
       DO ib_bdy=1, nb_bdy
-      !
-      SELECT CASE( nn_ice_lim(ib_bdy) )
-
-      CASE(jp_none)
-         CYCLE
-
-      CASE(jp_frs)
-
-         IF ( kn == 1 ) THEN ! set up of u_ice and v_ice
-           
-            jgrd = 2      ! u velocity
-            DO jb = 1, idx_bdy(ib_bdy)%nblen(jgrd)
-               ji    = idx_bdy(ib_bdy)%nbi(jb,jgrd)
-               jj    = idx_bdy(ib_bdy)%nbj(jb,jgrd)
-               zflag = idx_bdy(ib_bdy)%flagu(jb)
-
-               IF ( ABS( zflag ) == 1. ) THEN  ! eastern and western boundaries
-                  ! one of the two zmsk is always 0 (because of zflag)
-                  zmsk1 = 1._wp - MAX( 0.0_wp, SIGN ( 1.0_wp , - vt_i(ji+1,jj) ) ) ! 0 if no ice
-                  zmsk2 = 1._wp - MAX( 0.0_wp, SIGN ( 1.0_wp , - vt_i(ji-1,jj) ) ) ! 0 if no ice
+         !
+         SELECT CASE( nn_ice_lim(ib_bdy) )
+
+         CASE('none')
+
+            CYCLE
+            
+         CASE('frs')
+            
+
+            SELECT CASE ( cd_type )
+
+            CASE ( 'U' )
+               
+               jgrd = 2      ! u velocity
+               DO jb = 1, idx_bdy(ib_bdy)%nblen(jgrd)
+                  ji    = idx_bdy(ib_bdy)%nbi(jb,jgrd)
+                  jj    = idx_bdy(ib_bdy)%nbj(jb,jgrd)
+                  zflag = idx_bdy(ib_bdy)%flagu(jb)
                   
-                  ! u_ice = u_ice of the adjacent grid point except if this grid point is ice-free (then u_ice = u_oce)
-                  u_ice (ji,jj) = u_ice(ji+1,jj) * 0.5 * ABS( zflag + 1._wp ) * zmsk1 + &
-                     &            u_ice(ji-1,jj) * 0.5 * ABS( zflag - 1._wp ) * zmsk2 + &
-                     &            u_oce(ji  ,jj) * ( 1._wp - MIN( 1._wp, zmsk1 + zmsk2 ) )
-               ELSE                             ! everywhere else
-                  u_ice(ji,jj) = u_oce(ji,jj)
-               ENDIF
-               ! mask ice velocities
-               zinda = 1.0 - MAX( 0.0_wp, SIGN( 1.0_wp , - at_i(ji,jj) ) ) ! 0 if no ice
-               u_ice(ji,jj) = zinda * u_ice(ji,jj)
-
-            ENDDO
+                  IF ( ABS( zflag ) == 1. ) THEN  ! eastern and western boundaries
+                     ! one of the two zmsk is always 0 (because of zflag)
+                     zmsk1 = 1._wp - MAX( 0.0_wp, SIGN ( 1.0_wp , - vt_i(ji+1,jj) ) ) ! 0 if no ice
+                     zmsk2 = 1._wp - MAX( 0.0_wp, SIGN ( 1.0_wp , - vt_i(ji-1,jj) ) ) ! 0 if no ice
+                     
+                     ! u_ice = u_ice of the adjacent grid point except if this grid point is ice-free (then u_ice = u_oce)
+                     u_ice (ji,jj) = u_ice(ji+1,jj) * 0.5 * ABS( zflag + 1._wp ) * zmsk1 + &
+                        &            u_ice(ji-1,jj) * 0.5 * ABS( zflag - 1._wp ) * zmsk2 + &
+                        &            u_oce(ji  ,jj) * ( 1._wp - MIN( 1._wp, zmsk1 + zmsk2 ) )
+                  ELSE                             ! everywhere else
+                     !u_ice(ji,jj) = u_oce(ji,jj)
+                     u_ice(ji,jj) = 0._wp
+                  ENDIF
+                  ! mask ice velocities
+                  zinda = 1.0 - MAX( 0.0_wp , SIGN ( 1.0_wp , - at_i(ji,jj) + 0.01 ) ) ! 0 if no ice
+                  u_ice(ji,jj) = zinda * u_ice(ji,jj)
+                  
+               ENDDO
+
+               CALL lbc_bdy_lnk( u_ice(:,:), 'U', -1., ib_bdy )
+               
+            CASE ( 'V' )
+               
+               jgrd = 3      ! v velocity
+               DO jb = 1, idx_bdy(ib_bdy)%nblen(jgrd)
+                  ji    = idx_bdy(ib_bdy)%nbi(jb,jgrd)
+                  jj    = idx_bdy(ib_bdy)%nbj(jb,jgrd)
+                  zflag = idx_bdy(ib_bdy)%flagv(jb)
+                  
+                  IF ( ABS( zflag ) == 1. ) THEN  ! northern and southern boundaries
+                     ! one of the two zmsk is always 0 (because of zflag)
+                     zmsk1 = 1._wp - MAX( 0.0_wp, SIGN ( 1.0_wp , - vt_i(ji,jj+1) ) ) ! 0 if no ice
+                     zmsk2 = 1._wp - MAX( 0.0_wp, SIGN ( 1.0_wp , - vt_i(ji,jj-1) ) ) ! 0 if no ice
+                     
+                     ! u_ice = u_ice of the adjacent grid point except if this grid point is ice-free (then u_ice = u_oce)
+                     v_ice (ji,jj) = v_ice(ji,jj+1) * 0.5 * ABS( zflag + 1._wp ) * zmsk1 + &
+                        &            v_ice(ji,jj-1) * 0.5 * ABS( zflag - 1._wp ) * zmsk2 + &
+                        &            v_oce(ji,jj  ) * ( 1._wp - MIN( 1._wp, zmsk1 + zmsk2 ) )
+                  ELSE                             ! everywhere else
+                     !v_ice(ji,jj) = v_oce(ji,jj)
+                     v_ice(ji,jj) = 0._wp
+                  ENDIF
+                  ! mask ice velocities
+                  zinda = 1.0 - MAX( 0.0_wp , SIGN ( 1.0_wp , - at_i(ji,jj) + 0.01 ) ) ! 0 if no ice
+                  v_ice(ji,jj) = zinda * v_ice(ji,jj)
+                  
+               ENDDO
+               
+               CALL lbc_bdy_lnk( v_ice(:,:), 'V', -1., ib_bdy )
+               
+            END SELECT
             
-            jgrd = 3      ! v velocity
-            DO jb = 1, idx_bdy(ib_bdy)%nblen(jgrd)
-               ji    = idx_bdy(ib_bdy)%nbi(jb,jgrd)
-               jj    = idx_bdy(ib_bdy)%nbj(jb,jgrd)
-               zflag = idx_bdy(ib_bdy)%flagv(jb)
-              
-               IF ( ABS( zflag ) == 1. ) THEN  ! northern and southern boundaries
-                  ! one of the two zmsk is always 0 (because of zflag)
-                  zmsk1 = 1._wp - MAX( 0.0_wp, SIGN ( 1.0_wp , - vt_i(ji,jj+1) ) ) ! 0 if no ice
-                  zmsk2 = 1._wp - MAX( 0.0_wp, SIGN ( 1.0_wp , - vt_i(ji,jj-1) ) ) ! 0 if no ice
-                  
-                  ! u_ice = u_ice of the adjacent grid point except if this grid point is ice-free (then u_ice = u_oce)
-                  v_ice (ji,jj) = v_ice(ji,jj+1) * 0.5 * ABS( zflag + 1._wp ) * zmsk1 + &
-                     &            v_ice(ji,jj-1) * 0.5 * ABS( zflag - 1._wp ) * zmsk2 + &
-                     &            v_oce(ji,jj  ) * ( 1._wp - MIN( 1._wp, zmsk1 + zmsk2 ) )
-               ELSE                             ! everywhere else
-                  v_ice(ji,jj) = v_oce(ji,jj)
-               ENDIF
-               ! mask ice velocities
-               zinda = 1.0 - MAX( 0.0_wp, SIGN( 1.0_wp , - at_i(ji,jj) ) ) ! 0 if no ice
-               v_ice(ji,jj) = zinda * v_ice(ji,jj)
-
-            ENDDO
-            
-         CALL lbc_bdy_lnk( u_ice(:,:), 'U', -1., ib_bdy )
-         CALL lbc_bdy_lnk( v_ice(:,:), 'V', -1., ib_bdy )
- 
-         ELSEIF ( kn == 2 ) THEN ! set up of stress tensor (not sure it works)
+         CASE DEFAULT
+            CALL ctl_stop( 'bdy_ice_lim_dyn : unrecognised option for open boundaries for ice fields' )
+         END SELECT
          
-            jgrd = 1      ! T grid
-            DO jb = 1, idx_bdy(ib_bdy)%nblen(jgrd)
-               ji    = idx_bdy(ib_bdy)%nbi(jb,jgrd)
-               jj    = idx_bdy(ib_bdy)%nbj(jb,jgrd)
-
-               pvar1 (ji,jj) = 0._wp
-               pvar2 (ji,jj) = 0._wp
-               pvar12(ji,jj) = 0._wp
-
-            ENDDO
-
-         ENDIF
-
-      CASE DEFAULT
-         CALL ctl_stop( 'bdy_ice_lim_dyn : unrecognised option for open boundaries for ice fields' )
-      END SELECT
-
       ENDDO
 
       IF( nn_timing == 1 ) CALL timing_stop('bdy_ice_lim_dyn')
- 
+      
     END SUBROUTINE bdy_ice_lim_dyn
 
Index: /branches/2013/dev_MERGE_2013/NEMOGCM/NEMO/OPA_SRC/BDY/bdyini.F90
===================================================================
--- /branches/2013/dev_MERGE_2013/NEMOGCM/NEMO/OPA_SRC/BDY/bdyini.F90	(revision 4332)
+++ /branches/2013/dev_MERGE_2013/NEMOGCM/NEMO/OPA_SRC/BDY/bdyini.F90	(revision 4333)
@@ -488,6 +488,8 @@
             DO igrd = 1, jpbgrd
                id_dummy = iom_varid( inum, 'nbi'//cgrid(igrd), kdimsz=kdimsz )  
-               nblendta(igrd,ib_bdy) = kdimsz(1)
-               jpbdtau = MAX(jpbdtau, kdimsz(1))
+               !clem nblendta(igrd,ib_bdy) = kdimsz(1)
+               !clem jpbdtau = MAX(jpbdtau, kdimsz(1))
+               nblendta(igrd,ib_bdy) = MAXVAL(kdimsz)
+               jpbdtau = MAX(jpbdtau, MAXVAL(kdimsz))
             ENDDO
             CALL iom_close( inum )
Index: /branches/2013/dev_MERGE_2013/NEMOGCM/NEMO/OPA_SRC/DIA/diahsb.F90
===================================================================
--- /branches/2013/dev_MERGE_2013/NEMOGCM/NEMO/OPA_SRC/DIA/diahsb.F90	(revision 4332)
+++ /branches/2013/dev_MERGE_2013/NEMOGCM/NEMO/OPA_SRC/DIA/diahsb.F90	(revision 4333)
@@ -36,8 +36,8 @@
    LOGICAL, PUBLIC ::   ln_diahsb   !: check the heat and salt budgets
 
-   REAL(dp), SAVE                                ::   frc_t      , frc_s     , frc_v   ! global forcing trends
-   REAL(dp), ALLOCATABLE, SAVE, DIMENSION(:,:)   ::   ssh_ini              !
-   REAL(dp), ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   hc_loc_ini, sc_loc_ini, e3t_ini  !
-   REAL(dp), ALLOCATABLE, SAVE, DIMENSION(:,:)   ::   hcssh_loc_ini, scssh_loc_ini     !
+   REAL(wp), SAVE                                ::   frc_t      , frc_s     , frc_v   ! global forcing trends
+   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:)   ::   ssh_ini              !
+   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   hc_loc_ini, sc_loc_ini, e3t_ini  !
+   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:)   ::   hcssh_loc_ini, scssh_loc_ini     !
 
    !! * Substitutions
@@ -67,12 +67,12 @@
       !!
       INTEGER    ::   jk                          ! dummy loop indice
-      REAL(dp)   ::   zdiff_hc    , zdiff_sc      ! heat and salt content variations
-      REAL(dp)   ::   zdiff_v1    , zdiff_v2      ! volume variation
-      REAL(dp)   ::   z_hc        , z_sc          ! heat and salt content
-      REAL(dp)   ::   z_v1        , z_v2          ! volume
-      REAL(dp)   ::   zdeltat                     !    -     -
-      REAL(dp)   ::   z_frc_trd_t , z_frc_trd_s   !    -     -
-      REAL(dp)   ::   z_frc_trd_v                 !    -     -
-      REAL(dp), POINTER, DIMENSION(:,:)   ::   zsurf              !
+      REAL(wp)   ::   zdiff_hc    , zdiff_sc      ! heat and salt content variations
+      REAL(wp)   ::   zdiff_v1    , zdiff_v2      ! volume variation
+      REAL(wp)   ::   z_hc        , z_sc          ! heat and salt content
+      REAL(wp)   ::   z_v1        , z_v2          ! volume
+      REAL(wp)   ::   zdeltat                     !    -     -
+      REAL(wp)   ::   z_frc_trd_t , z_frc_trd_s   !    -     -
+      REAL(wp)   ::   z_frc_trd_v                 !    -     -
+      REAL(wp), POINTER, DIMENSION(:,:)   ::   zsurf              !
       !!---------------------------------------------------------------------------
       IF( nn_timing == 1 )   CALL timing_start('dia_hsb')      
@@ -104,20 +104,17 @@
       ! 2a -  Content variations !
       ! ------------------------ !
-      zdiff_v2 = 0._dp
-      zdiff_hc = 0._dp
-      zdiff_sc = 0._dp
+      zdiff_v2 = 0._wp
+      zdiff_hc = 0._wp
+      zdiff_sc = 0._wp
       ! volume variation (calculated with ssh)
       zdiff_v1 = glob_sum( zsurf(:,:) * ( sshn(:,:) - ssh_ini(:,:) ) )
       DO jk = 1, jpkm1
          ! volume variation (calculated with scale factors)
-         zdiff_v2 = zdiff_v2 &
-            &  + glob_sum( zsurf(:,:) * tmask(:,:,jk) * ( fse3t_n(:,:,jk) - e3t_ini(:,:,jk) ) )
+         zdiff_v2 = zdiff_v2 + glob_sum( zsurf(:,:) * tmask(:,:,jk) * ( fse3t_n(:,:,jk) - e3t_ini(:,:,jk) ) )
          ! heat content variation
-         zdiff_hc = zdiff_hc &
-            &  + glob_sum( zsurf(:,:) * tmask(:,:,jk) * ( fse3t_n(:,:,jk) * tsn(:,:,jk,jp_tem)   &
+         zdiff_hc = zdiff_hc + glob_sum( zsurf(:,:) * tmask(:,:,jk) * ( fse3t_n(:,:,jk) * tsn(:,:,jk,jp_tem)   &
             &                           - hc_loc_ini(:,:,jk) ) )
          ! salt content variation
-         zdiff_sc = zdiff_sc &
-            &  + glob_sum( zsurf(:,:) * tmask(:,:,jk) * ( fse3t_n(:,:,jk) * tsn(:,:,jk,jp_sal)   &
+         zdiff_sc = zdiff_sc + glob_sum( zsurf(:,:) * tmask(:,:,jk) * ( fse3t_n(:,:,jk) * tsn(:,:,jk,jp_sal)   &
             &                           - sc_loc_ini(:,:,jk) ) )
       ENDDO
@@ -140,19 +137,16 @@
       ! 2b -  Content           !
       ! ----------------------- !
-      z_v2 = 0._dp
-      z_hc = 0._dp
-      z_sc = 0._dp
+      z_v2 = 0._wp
+      z_hc = 0._wp
+      z_sc = 0._wp
       ! volume (calculated with ssh)
       z_v1 = glob_sum( zsurf(:,:) * sshn(:,:) )
       DO jk = 1, jpkm1
          ! volume (calculated with scale factors)
-         z_v2 = z_v2 &
-            &     + glob_sum( zsurf(:,:) * tmask(:,:,jk) * fse3t_n(:,:,jk) )
+         z_v2 = z_v2 + glob_sum( zsurf(:,:) * tmask(:,:,jk) * fse3t_n(:,:,jk) )
          ! heat content
-         z_hc = z_hc &
-            &     + glob_sum( zsurf(:,:) * tmask(:,:,jk) * fse3t_n(:,:,jk) * tsn(:,:,jk,jp_tem) )
+         z_hc = z_hc + glob_sum( zsurf(:,:) * tmask(:,:,jk) * fse3t_n(:,:,jk) * tsn(:,:,jk,jp_tem) )
          ! salt content
-         z_sc = z_sc &
-            &     + glob_sum( zsurf(:,:) * tmask(:,:,jk) * fse3t_n(:,:,jk) * tsn(:,:,jk,jp_sal) )
+         z_sc = z_sc + glob_sum( zsurf(:,:) * tmask(:,:,jk) * fse3t_n(:,:,jk) * tsn(:,:,jk,jp_sal) )
       ENDDO
       ! add ssh if not vvl
@@ -170,5 +164,5 @@
       CALL iom_put( 'bgtemper' , z_hc / z_v2 )                      ! Temperature (C) 
       CALL iom_put( 'bgsaline' , z_sc / z_v2 )                      ! Salinity (psu)
-      CALL iom_put( 'bgheatco' , zdiff_hc * rau0 * rcp * 1.e-9_dp ) ! Heat content variation (10^9 J)
+      CALL iom_put( 'bgheatco' , zdiff_hc * rau0 * rcp * 1.e-9_wp ) ! Heat content variation (10^9 J)
       CALL iom_put( 'bgsaltco' , zdiff_sc * 1.e-9 )                 ! Salt content variation (psu*km3) 
       CALL iom_put( 'bgvolssh' , zdiff_v1 * 1.e-9 )                    ! volume ssh (km3)  
@@ -176,5 +170,5 @@
       CALL iom_put( 'bgvoltot' , zdiff_v2 * 1.e-9 )                 ! volume total (km3) 
       CALL iom_put( 'bgfrcvol' , frc_v * 1.e-9 )                     ! vol - surface forcing (volume) 
-      CALL iom_put( 'bgfrctem' , frc_t * rau0 * rcp * 1.e-9_dp ) ! hc  - surface forcing (heat content) 
+      CALL iom_put( 'bgfrctem' , frc_t * rau0 * rcp * 1.e-9_wp ) ! hc  - surface forcing (heat content) 
       CALL iom_put( 'bgfrcsal' , frc_s * 1.e-9 )                     ! sc  - surface forcing (salt content) 
       !
@@ -224,4 +218,6 @@
       IF(lwp) THEN                   ! Control print
          WRITE(numout,*)
+         WRITE(numout,*) 'dia_hsb_init : check the heat and salt budgets'
+         WRITE(numout,*) '~~~~~~~~~~~~'
          WRITE(numout,*) '   Namelist namhsb : set hsb parameters'
          WRITE(numout,*) '      Switch for hsb diagnostic (T) or not (F)  ln_diahsb  = ', ln_diahsb
@@ -308,7 +304,7 @@
           hcssh_loc_ini(:,:) = tsn(:,:,1,jp_tem) * sshn(:,:)   ! initial heat content in ssh
           scssh_loc_ini(:,:) = tsn(:,:,1,jp_sal) * sshn(:,:)   ! initial salt content in ssh
-          frc_v = 0._dp                                           
-          frc_t = 0._dp                                           
-          frc_s = 0._dp                                                  
+          frc_v = 0._wp                                           
+          frc_t = 0._wp                                           
+          frc_s = 0._wp                                                  
        ENDIF
 
Index: /branches/2013/dev_MERGE_2013/NEMOGCM/NEMO/OPA_SRC/IOM/restart.F90
===================================================================
--- /branches/2013/dev_MERGE_2013/NEMOGCM/NEMO/OPA_SRC/IOM/restart.F90	(revision 4332)
+++ /branches/2013/dev_MERGE_2013/NEMOGCM/NEMO/OPA_SRC/IOM/restart.F90	(revision 4333)
@@ -23,4 +23,5 @@
    USE eosbn2          ! equation of state            (eos bn2 routine)
    USE trdmld_oce      ! ocean active mixed layer tracers trends variables
+   USE domvvl          ! variable volume
    USE divcur          ! hor. divergence and curl      (div & cur routines)
    USE sbc_ice, ONLY : lk_lim3
@@ -210,4 +211,5 @@
          CALL iom_get( numror, jpdom_autoglo, 'hdivb'  , hdivb   )
          CALL iom_get( numror, jpdom_autoglo, 'sshb'   , sshb    )
+         IF( lk_vvl )   CALL iom_get( numror, jpdom_autoglo, 'fse3t_b', fse3t_b(:,:,:) )
       ELSE
          neuler = 0
Index: /branches/2013/dev_MERGE_2013/NEMOGCM/NEMO/OPA_SRC/SBC/sbcblk_core.F90
===================================================================
--- /branches/2013/dev_MERGE_2013/NEMOGCM/NEMO/OPA_SRC/SBC/sbcblk_core.F90	(revision 4332)
+++ /branches/2013/dev_MERGE_2013/NEMOGCM/NEMO/OPA_SRC/SBC/sbcblk_core.F90	(revision 4333)
@@ -793,9 +793,9 @@
         Cd_n10(:,:) =   cdn_wave
       ELSE
-        Cd_n10  = 1E-3 * ( 2.7/dU10 + 0.142 + dU10/13.09 )    !   L & Y eq. (6a)
+        Cd_n10  = 1.e-3 * ( 2.7/dU10 + 0.142 + dU10/13.09 )    !   L & Y eq. (6a)
       ENDIF
       sqrt_Cd_n10 = sqrt(Cd_n10)
-      Ce_n10  = 1E-3 * ( 34.6 * sqrt_Cd_n10 )               !   L & Y eq. (6b)
-      Ch_n10  = 1E-3*sqrt_Cd_n10*(18*stab + 32.7*(1-stab)) !   L & Y eq. (6c), (6d)
+      Ce_n10  = 1.e-3 * ( 34.6 * sqrt_Cd_n10 )               !   L & Y eq. (6b)
+      Ch_n10  = 1.e-3*sqrt_Cd_n10*(18.*stab + 32.7*(1.-stab)) !   L & Y eq. (6c), (6d)
       !!
       !! Initializing transfert coefficients with their first guess neutral equivalents :
@@ -824,9 +824,9 @@
 
            !! Updating the neutral 10m transfer coefficients :
-           Cd_n10  = 1E-3 * (2.7/U_n10 + 0.142 + U_n10/13.09)              !  L & Y eq. (6a)
+           Cd_n10  = 1.e-3 * (2.7/U_n10 + 0.142 + U_n10/13.09)              !  L & Y eq. (6a)
            sqrt_Cd_n10 = sqrt(Cd_n10)
-           Ce_n10  = 1E-3 * (34.6 * sqrt_Cd_n10)                           !  L & Y eq. (6b)
+           Ce_n10  = 1.e-3 * (34.6 * sqrt_Cd_n10)                           !  L & Y eq. (6b)
            stab    = 0.5 + sign(0.5,zeta)
-           Ch_n10  = 1E-3*sqrt_Cd_n10*(18.*stab + 32.7*(1-stab))           !  L & Y eq. (6c), (6d)
+           Ch_n10  = 1.e-3*sqrt_Cd_n10*(18.*stab + 32.7*(1.-stab))           !  L & Y eq. (6c), (6d)
 
            !! Shifting the neutral  10m transfer coefficients to ( zu , zeta ) :
@@ -927,9 +927,9 @@
         Cd_n10(:,:) =   cdn_wave
       ELSE
-        Cd_n10  = 1E-3*( 2.7/dU10 + 0.142 + dU10/13.09 ) 
+        Cd_n10  = 1.e-3*( 2.7/dU10 + 0.142 + dU10/13.09 ) 
       ENDIF
       sqrt_Cd_n10 = sqrt(Cd_n10)
-      Ce_n10  = 1E-3*( 34.6 * sqrt_Cd_n10 )
-      Ch_n10  = 1E-3*sqrt_Cd_n10*(18*stab + 32.7*(1 - stab))
+      Ce_n10  = 1.e-3*( 34.6 * sqrt_Cd_n10 )
+      Ch_n10  = 1.e-3*sqrt_Cd_n10*(18.*stab + 32.7*(1. - stab))
 
       !! Initializing transf. coeff. with their first guess neutral equivalents :
@@ -973,9 +973,9 @@
          ELSE
            !! Updating the neutral 10m transfer coefficients :
-           Cd_n10  = 1E-3 * (2.7/U_n10 + 0.142 + U_n10/13.09)    ! L & Y eq. (6a)
+           Cd_n10  = 1.e-3 * (2.7/U_n10 + 0.142 + U_n10/13.09)    ! L & Y eq. (6a)
            sqrt_Cd_n10 = sqrt(Cd_n10)
-           Ce_n10  = 1E-3 * (34.6 * sqrt_Cd_n10)                 ! L & Y eq. (6b)
+           Ce_n10  = 1.e-3 * (34.6 * sqrt_Cd_n10)                 ! L & Y eq. (6b)
            stab    = 0.5 + sign(0.5,zeta_u)
-           Ch_n10  = 1E-3*sqrt_Cd_n10*(18.*stab + 32.7*(1-stab)) ! L & Y eq. (6c-6d)
+           Ch_n10  = 1.e-3*sqrt_Cd_n10*(18.*stab + 32.7*(1.-stab)) ! L & Y eq. (6c-6d)
            !!
            !!
